{-|
Module:             Text.IO
Description:        IO for Text handling.
Copyright:          © 2016 All rights reserved.
License:            GPL-3
Maintainer:         Evan Cofsky <>
Stability:          experimental
Portability:        POSIX
-}

module Text.IO (
    readFile,
    writeFile,
    appendFile,
    TIO.hGetLine,
    TIO.hPutStr,
    TIO.hPutStrLn,
    TIO.getLine,
    TIO.putStr,
    TIO.putStrLn
    ) where

import System.IO (IO)
import Prelude.Unicode ((∘))
import Path
import qualified Data.Text.IO as TIO
import Data.Text (Text)
import qualified System.Path.PartClass as Class

readFile ∷ Class.AbsRel ar ⇒ FilePath ar → IO Text
readFile = TIO.readFile ∘ toString

writeFile ∷ Class.AbsRel ar ⇒ FilePath ar → Text → IO ()
writeFile = TIO.writeFile ∘ toString

appendFile ∷ Class.AbsRel ar ⇒ FilePath ar → Text → IO ()
appendFile = TIO.appendFile ∘ toString
